# encoding: utf-8

# this module overrides some active support methods for working paths etc.
module Activesupport
  include ActionView::Context
  include ActionView::Helpers

  def path_to_stylesheet(path, _options = {})
    return path if external_path?(path)
    append_asset_version @project.uri_path_to(:styles, path)
  end

  def path_to_javascript(path, path_options={})
    return path if external_path? path
    append_asset_version @project.uri_path_to(:scripts, path)
  end

  def path_to_image(path)
    return path if external_path? path
    append_asset_version @project.uri_path_to(:images, path)
  end

  def append_asset_version(input)
    time = Time.now.to_i
    input.include?('?') ? "#{input}&t=#{time}" : "#{input}?t=#{time}"
  end

  alias_method :orig_content_for, :content_for
  def content_for(name, content = nil, options = {}, &block)
    if block_given?
      options = content if content
      content = capture_haml(&block).html_safe
    end
    orig_content_for(name, content , options)
  end
end
