# encoding: utf-8

# this class helps with haml layout files
class EasyHtmlGenerator::Generator::Compile::Haml::Layout
  @layouts = {}

  def self.layout_from_file(haml_folder, template, config)
    first_line = File.readlines(template).first

    if first_line.include? '-# ehg layout:'
      name = first_line.sub('-# ehg layout:', '').strip
    else
      name = 'layout'
    end

    path  = "#{haml_folder}#{name}.haml"
    path  = "#{haml_folder}#{config.default_layout}.haml" unless File.exist? path

    load_from_file(path, config.renderer) if should_load_from_file path

    @layouts[path]
  end

  def self.should_load_from_file(layout_file)
    return true unless @layouts.key? layout_file
    EasyHtmlGenerator::Checksum.file_changed? layout_file
  end

  def self.load_from_file(layout_file, haml_config)
    fail "layout not found '#{layout_file}'" unless File.exist? layout_file
    @layouts[layout_file] = Haml::Engine.new(File.read(layout_file),
                                             haml_config)
    EasyHtmlGenerator::Checksum.store_file(layout_file)
  end
end
