# encoding: utf-8
require 'fileutils'
require 'easy_html_generator/generator/base'

# this generator copies files from src ro dist folder
class EasyHtmlGenerator::Generator::Copy <
  EasyHtmlGenerator::Generator::Base

  def generate!(config)
    selector = config.key?(:selector) ? config[:selector] : '**/*'

    self.class.copy_r(config.source, config.target, selector)
  end

  # cannot use copy_entry or cp_r with symbolic existent links in target
  def self.copy_r(src_path, dest_path, selector)
    return unless File.exist? src_path

    Dir[File.join(src_path, selector)].each do |input_file|
      next if input_file.empty?

      output_file = input_file.sub(src_path, dest_path)

      FileUtils.mkdir_p File.dirname(output_file)

      copy(input_file, output_file)
    end
  end

  def self.copy(input_file, output_file)
    if File.directory? input_file
      FileUtils.mkdir_p(output_file) unless File.exist? output_file
    else
      FileUtils.copy input_file, output_file
    end
  end
end
