# encoding: utf-8
require 'cssminify'
require 'easy_html_generator/generator/compile/base'

# this generator minifies css files from src folder and copies them
# to the dist folder
class EasyHtmlGenerator::Generator::Minimize::Css <
  EasyHtmlGenerator::Generator::Compile::Base

  def do_input!(input, *_args)
    self.class.compress input
  end

  def input_to_output_file(input_file, config)
    super(input_file, config).gsub(/\.css$/, "#{config.prefix_extension}.css")
  end

  def self.compress(input)
    CSSminify.compress input
  end
end
