# encoding: utf-8
require 'htmlcompressor'
require 'easy_html_generator/generator/compile/base'

# this generator minifies html files from src folder and copies them
# to the dist folder
class EasyHtmlGenerator::Generator::Minimize::Html <
  EasyHtmlGenerator::Generator::Compile::Base

  def do_input!(input, *_args)
    self.class.compress input
  end

  def input_to_output_file(input_file, config)
    super(input_file, config).gsub(/\.html$/, "#{config.prefix_extension}.html")
  end

  def self.compressor
    @compressor ||= HtmlCompressor::Compressor.new
  end

  def self.compress(input)
    compressor.compress input
  end
end
