# encoding: utf-8
require 'piet'
require 'easy_html_generator/generator/compile/base'

# this generator minifies image files from src folder and copies them
# to the dist folder
class EasyHtmlGenerator::Generator::Minimize::Images <
  EasyHtmlGenerator::Generator::Compile::Base

  def do_input!(_input, input_file, output_file, config)
    FileUtils.copy(input_file, output_file) unless input_file == output_file

    Piet.optimize(output_file, config.options)

    nil
  rescue StandardError
    log '-> you have to install "optipng" and "jpegoptim"'.red
  end
end
