# encoding: utf-8
require 'fileutils'
require 'easy_html_generator/generator/base'

# this generator resolves and runs a bower.json
class EasyHtmlGenerator::Generator::Service::Bower <
  EasyHtmlGenerator::Generator::Base

  def generate!(_config)
    return unless File.exist? bower_file
    return unless file_changed? bower_file

    log `  #{bower_command}  `

    FileUtils.mkdir_p @config.target

    EasyHtmlGenerator::Generator::Copy.copy_r(
      bower_storage, @config.target, '**/*')

    store_file_hash(bower_file)
  end

  def bower_storage
    File.join(@config.source, 'bower_components')
  end

  def bower_file
    File.join(@config.source, 'bower.json')
  end

  def bower_command
    command = "cd #{@config.source} && bower install --force-latest"

    "if which bower >/dev/null; then echo '\e[32mrunning bower\e[0m' \
    && #{command}; else echo '\e[31mplease install bower \
    \"npm install -g bower\" http://bower.io/ \e[0m'; fi"
  end
end
